//+------------------------------------------------------------------+
//|                                                        Sidus.mq4 |
//|                                                  Daniel Frieling |
//|                                                      noch Keinen |
//|                                                    Idea by Sidus |
//+------------------------------------------------------------------+
#property copyright "Daniel Frieling"
#property link      ""
 
extern int    slowPeriod    = 12;
extern int    fastPeriod    = 5;
extern double Lots          = 0.1;  
extern double StopLoss      = 50;
extern bool   TrailingStop  = false;  
extern double TrailingAct   = 20;
extern double TrailingStep  = 5;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
{
//----
//----
  return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
{
//----
   
//----
  return(0);
}
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
//---------------- INDICATORS

  double slowEMA, slowEMABefore, fastEMA, fastEMABefore;
  double rsi;
   
  slowEMA       = iMA(NULL, 0, slowPeriod, 0, MODE_EMA, PRICE_OPEN, 0);
  slowEMABefore = iMA(NULL, 0, slowPeriod, 0, MODE_EMA, PRICE_OPEN, 1);
  fastEMA       = iMA(NULL, 0, fastPeriod, 0, MODE_EMA, PRICE_OPEN, 0);
  fastEMABefore = iMA(NULL, 0, fastPeriod, 0, MODE_EMA, PRICE_OPEN, 1);
  
  rsi = iRSI(NULL, 0, 21, PRICE_CLOSE, 0);
    
//---------------- ENTRY / EXIT SIGNALS

  bool longOk = false;
  bool shortOk = false;
  bool sellOk = false;
  bool coverOk = false;
  
  if(fastEMA >= slowEMA && fastEMABefore <= slowEMABefore && rsi >= 50)
  {
    coverOk = true;
    longOk = true;
  }
    
  if(fastEMA <= slowEMA && fastEMABefore >= slowEMABefore && rsi <= 50)
  {
    sellOk = true;
    shortOk = true;
  }
    
  
//------------------------------
//---------------- START ORDERS
  
  int cnt, ticket, total;
  bool orderIsOpen = false;
  
  total = OrdersTotal();  // Currently open or pending orders
  for(cnt = 0; cnt < total; cnt++)
  {
    OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
    if( (OrderSymbol() == Symbol()) && (OrderMagicNumber() == 221188) )
    {
      orderIsOpen = true;
      break;
    }
    else
      continue; 
  }  
  
  if(!orderIsOpen) // if no order is open
  {
    if(longOk) // if you want to go long
    {
      ticket = OrderSend(Symbol(), OP_BUY, Lots, Ask, 3, Ask-StopLoss*Point, 0, "Sidus", 221188, 0, GreenYellow);
      
      if(ticket > 0) // if order opening suceeded
      {
        if(OrderSelect(ticket, SELECT_BY_TICKET,MODE_TRADES)) 
          Print("BUY order opened @ "+OrderOpenPrice());
      }
      else 
        Print("Error opening BUY order : "+GetLastError()); 
        
      return(0);
    }

    if(shortOk) // if you want to go short
    {
      ticket = OrderSend(Symbol(), OP_SELL, Lots, Bid, 3, Bid+StopLoss*Point, 0, "Sidus", 221188, 0, Red);
      
      if(ticket > 0) // if order opening suceeded
      {
        if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) 
          Print("SELL order opened @ "+OrderOpenPrice());
      }
      else 
        Print("Error opening SELL order : "+GetLastError()); 
        
      return(0);
    }
  }
//---------------------------------------------------------  
//----------------- CHECK CLOSE/TRAILING STOP ORDERS  
  total = OrdersTotal();
  for(cnt = 0; cnt < total; cnt++)
  {
    OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
    
    if( (OrderType() <= OP_SELL) && (OrderSymbol() == Symbol()) && (OrderMagicNumber() == 221188) )
    {
      if(OrderType() == OP_BUY)
      {
        if(TrailingStop)
        {
          if((Bid-OrderOpenPrice()) > (Point*TrailingAct))  // if you are 'TrailingAct' or higer in Profit
          {
            if((OrderStopLoss()) < (Bid-Point*TrailingStep))  // if S/L is lower than Bid-'TrailingStep'
            {
              OrderModify(OrderTicket(), OrderOpenPrice() ,Bid-Point*TrailingStep, 0, 0, GreenYellow);
              return(0);
            }
          } 
        }                  
 
        if(sellOk)  // if signal is on SELL
        {
          OrderClose(OrderTicket(), OrderLots(), Bid, 3, Violet); 
          return(0); 
        }
      }

      if(OrderType() == OP_SELL)
      {
        if(TrailingStop > 0)
        {
          if(OrderOpenPrice()-Ask>Point*TrailingStop)
          {
            if(OrderStopLoss()>Ask+Point*TrailingStop)
            {
              OrderModify(OrderTicket(), OrderOpenPrice(), Ask+Point*TrailingStop, 0, 0, Red);
              return(0);              
            }
          }     
        }
        
        if(coverOk)
        {
          OrderClose(OrderTicket(), OrderLots(), Bid, 3, Violet); 
          return(0); 
        }

      }
    }
  }

//------------------------------  
  return(0);
}
//+------------------------------------------------------------------+